/* Recoloring.c generated by valac 0.56.17, the Vala compiler
 * generated from Recoloring.vala, do not modify */

/* SPDX-FileCopyrightText: 2021 Christian Hergert <chergert@redhat.com>*/
/* SPDX-FileCopyrightText: 2022 Gleb Smirnov <glebsmirnov0708@gmail.com>*/
/**/
/* SPDX-License-Identifier: GPL-3.0-or-later*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtksourceview/gtksource.h>
#include <float.h>
#include <math.h>

#define SHARED_CSS "\n" \
"@define-color card_fg_color @window_fg_color;\n" \
"@define-color headerbar_fg_color @window_fg_color;\n" \
"@define-color headerbar_border_color @window_fg_color;\n" \
"@define-color popover_fg_color @window_fg_color;\n" \
"@define-color dark_fill_bg_color @headerbar_bg_color;\n" \
"@define-color view_bg_color @card_bg_color;\n" \
"@define-color view_fg_color @window_fg_color;\n"
#define LIGHT_CSS_SUFFIX "\n" \
"@define-color popover_bg_color mix(@window_bg_color, white, .1);\n" \
"@define-color card_bg_color alpha(white, .6);\n"
#define DARK_CSS_SUFFIX "\n" \
"@define-color popover_bg_color mix(@window_bg_color, white, 0.07);\n" \
"@define-color card_bg_color @popover_bg_color;\n" \
"@define-color view_bg_color darker(@window_bg_color);\n"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	RECOLORING_COLOR_KIND_FOREGROUND,
	RECOLORING_COLOR_KIND_BACKGROUND
} RecoloringColorKind;

#define RECOLORING_TYPE_COLOR_KIND (recoloring_color_kind_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

VALA_EXTERN GType recoloring_color_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GdkRGBA* recoloring_parse_color (const gchar* color);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
VALA_EXTERN GdkRGBA* recoloring_get_color (GtkSourceStyleScheme* scheme,
                               const gchar* style_name,
                               RecoloringColorKind kind);
VALA_EXTERN GdkRGBA* recoloring_get_metadata_color (GtkSourceStyleScheme* scheme,
                                        const gchar* key);
VALA_EXTERN void recoloring_define_color (GString* str,
                              const gchar* name,
                              GdkRGBA* color);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN void recoloring_define_color_mixed (GString* str,
                                    const gchar* name,
                                    GdkRGBA* a,
                                    GdkRGBA* b,
                                    gdouble level);
VALA_EXTERN gboolean recoloring_is_scheme_dark (GtkSourceStyleScheme* scheme);
VALA_EXTERN gchar* recoloring_generate_css (GtkSourceStyleScheme* style_scheme);

/**
     * Color kind
     *
     * Can be background or foreground.
     */
static GType
recoloring_color_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{RECOLORING_COLOR_KIND_FOREGROUND, "RECOLORING_COLOR_KIND_FOREGROUND", "foreground"}, {RECOLORING_COLOR_KIND_BACKGROUND, "RECOLORING_COLOR_KIND_BACKGROUND", "background"}, {0, NULL, NULL}};
	GType recoloring_color_kind_type_id;
	recoloring_color_kind_type_id = g_enum_register_static ("RecoloringColorKind", values);
	return recoloring_color_kind_type_id;
}

GType
recoloring_color_kind_get_type (void)
{
	static volatile gsize recoloring_color_kind_type_id__once = 0;
	if (g_once_init_enter (&recoloring_color_kind_type_id__once)) {
		GType recoloring_color_kind_type_id;
		recoloring_color_kind_type_id = recoloring_color_kind_get_type_once ();
		g_once_init_leave (&recoloring_color_kind_type_id__once, recoloring_color_kind_type_id);
	}
	return recoloring_color_kind_type_id__once;
}

/**
     * Try to parse color string
     *
     * Returns `null` if string is invalid.
     *
     * @param color color string
     *
     * @return color got from string, or `null` if string is invalid
     */
static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
#line 69 "../src/utils/Recoloring.vala"
	return g_boxed_copy (gdk_rgba_get_type (), self);
#line 111 "Recoloring.c"
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
#line 69 "../src/utils/Recoloring.vala"
	return self ? _vala_GdkRGBA_copy (self) : NULL;
#line 119 "Recoloring.c"
}

GdkRGBA*
recoloring_parse_color (const gchar* color)
{
	GdkRGBA rgba = {0};
	GdkRGBA* result;
#line 65 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 66 "../src/utils/Recoloring.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 68 "../src/utils/Recoloring.vala"
	if (gdk_rgba_parse (&rgba, color)) {
#line 133 "Recoloring.c"
		GdkRGBA* _tmp0_;
#line 69 "../src/utils/Recoloring.vala"
		_tmp0_ = __vala_GdkRGBA_copy0 (&rgba);
#line 69 "../src/utils/Recoloring.vala"
		result = _tmp0_;
#line 69 "../src/utils/Recoloring.vala"
		return result;
#line 141 "Recoloring.c"
	} else {
#line 71 "../src/utils/Recoloring.vala"
		result = NULL;
#line 71 "../src/utils/Recoloring.vala"
		return result;
#line 147 "Recoloring.c"
	}
}

/**
     * Get color from style scheme
     *
     * @param scheme style scheme
     * @param style_name style name that color is belong to
     * @param kind color kind
     *
     * @return color
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "../src/utils/Recoloring.vala"
	return self ? g_object_ref (self) : NULL;
#line 165 "Recoloring.c"
}

GdkRGBA*
recoloring_get_color (GtkSourceStyleScheme* scheme,
                      const gchar* style_name,
                      RecoloringColorKind kind)
{
	GtkSourceStyle* style = NULL;
	GtkSourceStyle* _tmp0_;
	GtkSourceStyle* _tmp1_;
	GtkSourceStyle* _tmp2_;
	gchar* fg = NULL;
	GtkSourceStyle* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean fg_set = FALSE;
	GtkSourceStyle* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gchar* bg = NULL;
	GtkSourceStyle* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean bg_set = FALSE;
	GtkSourceStyle* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GdkRGBA color = {0};
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GdkRGBA _tmp23_;
	GdkRGBA* result;
#line 83 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 83 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (style_name != NULL, NULL);
#line 84 "../src/utils/Recoloring.vala"
	_tmp0_ = gtk_source_style_scheme_get_style (scheme, style_name);
#line 84 "../src/utils/Recoloring.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 84 "../src/utils/Recoloring.vala"
	style = _tmp1_;
#line 86 "../src/utils/Recoloring.vala"
	_tmp2_ = style;
#line 86 "../src/utils/Recoloring.vala"
	if (_tmp2_ == NULL) {
#line 87 "../src/utils/Recoloring.vala"
		result = NULL;
#line 87 "../src/utils/Recoloring.vala"
		_g_object_unref0 (style);
#line 87 "../src/utils/Recoloring.vala"
		return result;
#line 218 "Recoloring.c"
	}
#line 89 "../src/utils/Recoloring.vala"
	_tmp3_ = style;
#line 89 "../src/utils/Recoloring.vala"
	g_object_get (_tmp3_, "foreground", &_tmp4_, NULL);
#line 89 "../src/utils/Recoloring.vala"
	_tmp5_ = _tmp4_;
#line 89 "../src/utils/Recoloring.vala"
	fg = _tmp5_;
#line 90 "../src/utils/Recoloring.vala"
	_tmp6_ = style;
#line 90 "../src/utils/Recoloring.vala"
	g_object_get (_tmp6_, "foreground-set", &_tmp7_, NULL);
#line 90 "../src/utils/Recoloring.vala"
	_tmp8_ = _tmp7_;
#line 90 "../src/utils/Recoloring.vala"
	fg_set = _tmp8_;
#line 91 "../src/utils/Recoloring.vala"
	_tmp9_ = style;
#line 91 "../src/utils/Recoloring.vala"
	g_object_get (_tmp9_, "background", &_tmp10_, NULL);
#line 91 "../src/utils/Recoloring.vala"
	_tmp11_ = _tmp10_;
#line 91 "../src/utils/Recoloring.vala"
	bg = _tmp11_;
#line 92 "../src/utils/Recoloring.vala"
	_tmp12_ = style;
#line 92 "../src/utils/Recoloring.vala"
	g_object_get (_tmp12_, "background-set", &_tmp13_, NULL);
#line 92 "../src/utils/Recoloring.vala"
	_tmp14_ = _tmp13_;
#line 92 "../src/utils/Recoloring.vala"
	bg_set = _tmp14_;
#line 94 "../src/utils/Recoloring.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 96 "../src/utils/Recoloring.vala"
	if (kind == RECOLORING_COLOR_KIND_FOREGROUND) {
#line 256 "Recoloring.c"
		const gchar* _tmp17_;
#line 96 "../src/utils/Recoloring.vala"
		_tmp17_ = fg;
#line 96 "../src/utils/Recoloring.vala"
		_tmp16_ = _tmp17_ != NULL;
#line 262 "Recoloring.c"
	} else {
#line 96 "../src/utils/Recoloring.vala"
		_tmp16_ = FALSE;
#line 266 "Recoloring.c"
	}
#line 96 "../src/utils/Recoloring.vala"
	if (_tmp16_) {
#line 96 "../src/utils/Recoloring.vala"
		_tmp15_ = fg_set;
#line 272 "Recoloring.c"
	} else {
#line 96 "../src/utils/Recoloring.vala"
		_tmp15_ = FALSE;
#line 276 "Recoloring.c"
	}
#line 96 "../src/utils/Recoloring.vala"
	if (_tmp15_) {
#line 280 "Recoloring.c"
		const gchar* _tmp18_;
#line 97 "../src/utils/Recoloring.vala"
		_tmp18_ = fg;
#line 97 "../src/utils/Recoloring.vala"
		gdk_rgba_parse (&color, _tmp18_);
#line 286 "Recoloring.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 98 "../src/utils/Recoloring.vala"
		if (kind == RECOLORING_COLOR_KIND_BACKGROUND) {
#line 292 "Recoloring.c"
			const gchar* _tmp21_;
#line 98 "../src/utils/Recoloring.vala"
			_tmp21_ = bg;
#line 98 "../src/utils/Recoloring.vala"
			_tmp20_ = _tmp21_ != NULL;
#line 298 "Recoloring.c"
		} else {
#line 98 "../src/utils/Recoloring.vala"
			_tmp20_ = FALSE;
#line 302 "Recoloring.c"
		}
#line 98 "../src/utils/Recoloring.vala"
		if (_tmp20_) {
#line 98 "../src/utils/Recoloring.vala"
			_tmp19_ = bg_set;
#line 308 "Recoloring.c"
		} else {
#line 98 "../src/utils/Recoloring.vala"
			_tmp19_ = FALSE;
#line 312 "Recoloring.c"
		}
#line 98 "../src/utils/Recoloring.vala"
		if (_tmp19_) {
#line 316 "Recoloring.c"
			const gchar* _tmp22_;
#line 99 "../src/utils/Recoloring.vala"
			_tmp22_ = bg;
#line 99 "../src/utils/Recoloring.vala"
			gdk_rgba_parse (&color, _tmp22_);
#line 322 "Recoloring.c"
		} else {
#line 101 "../src/utils/Recoloring.vala"
			result = NULL;
#line 101 "../src/utils/Recoloring.vala"
			_g_free0 (bg);
#line 101 "../src/utils/Recoloring.vala"
			_g_free0 (fg);
#line 101 "../src/utils/Recoloring.vala"
			_g_object_unref0 (style);
#line 101 "../src/utils/Recoloring.vala"
			return result;
#line 334 "Recoloring.c"
		}
	}
#line 103 "../src/utils/Recoloring.vala"
	_tmp23_ = color;
#line 103 "../src/utils/Recoloring.vala"
	if (((gdouble) _tmp23_.alpha) >= 0.1) {
#line 341 "Recoloring.c"
		GdkRGBA* _tmp24_;
#line 104 "../src/utils/Recoloring.vala"
		_tmp24_ = __vala_GdkRGBA_copy0 (&color);
#line 104 "../src/utils/Recoloring.vala"
		result = _tmp24_;
#line 104 "../src/utils/Recoloring.vala"
		_g_free0 (bg);
#line 104 "../src/utils/Recoloring.vala"
		_g_free0 (fg);
#line 104 "../src/utils/Recoloring.vala"
		_g_object_unref0 (style);
#line 104 "../src/utils/Recoloring.vala"
		return result;
#line 355 "Recoloring.c"
	} else {
#line 106 "../src/utils/Recoloring.vala"
		result = NULL;
#line 106 "../src/utils/Recoloring.vala"
		_g_free0 (bg);
#line 106 "../src/utils/Recoloring.vala"
		_g_free0 (fg);
#line 106 "../src/utils/Recoloring.vala"
		_g_object_unref0 (style);
#line 106 "../src/utils/Recoloring.vala"
		return result;
#line 367 "Recoloring.c"
	}
}

/**
     * Get color from style scheme metadata
     *
     * @param scheme style scheme
     * @param key color key
     *
     * @return color, or `null` if not defined
     */
GdkRGBA*
recoloring_get_metadata_color (GtkSourceStyleScheme* scheme,
                               const gchar* key)
{
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GdkRGBA* result;
#line 117 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 117 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 118 "../src/utils/Recoloring.vala"
	_tmp0_ = gtk_source_style_scheme_get_metadata (scheme, key);
#line 118 "../src/utils/Recoloring.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 118 "../src/utils/Recoloring.vala"
	str = _tmp1_;
#line 120 "../src/utils/Recoloring.vala"
	_tmp2_ = str;
#line 120 "../src/utils/Recoloring.vala"
	if (_tmp2_ == NULL) {
#line 121 "../src/utils/Recoloring.vala"
		result = NULL;
#line 121 "../src/utils/Recoloring.vala"
		_g_free0 (str);
#line 121 "../src/utils/Recoloring.vala"
		return result;
#line 408 "Recoloring.c"
	} else {
		const gchar* _tmp3_;
		GdkRGBA* _tmp4_;
#line 123 "../src/utils/Recoloring.vala"
		_tmp3_ = str;
#line 123 "../src/utils/Recoloring.vala"
		_tmp4_ = recoloring_parse_color (_tmp3_);
#line 123 "../src/utils/Recoloring.vala"
		result = _tmp4_;
#line 123 "../src/utils/Recoloring.vala"
		_g_free0 (str);
#line 123 "../src/utils/Recoloring.vala"
		return result;
#line 422 "Recoloring.c"
	}
}

/**
     * Define color in CSS string builder
     *
     * @param str CSS string builder
     * @param name color name
     * @param color color to define
     */
static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 133 "../src/utils/Recoloring.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 438 "Recoloring.c"
}

void
recoloring_define_color (GString* str,
                         const gchar* name,
                         GdkRGBA* color)
{
	GdkRGBA* opaque = NULL;
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	gchar* color_str = NULL;
	GdkRGBA* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
#line 133 "../src/utils/Recoloring.vala"
	g_return_if_fail (str != NULL);
#line 133 "../src/utils/Recoloring.vala"
	g_return_if_fail (name != NULL);
#line 134 "../src/utils/Recoloring.vala"
	if (color == NULL) {
#line 135 "../src/utils/Recoloring.vala"
		return;
#line 461 "Recoloring.c"
	}
#line 137 "../src/utils/Recoloring.vala"
	_tmp0_ = gdk_rgba_copy (color);
#line 137 "../src/utils/Recoloring.vala"
	opaque = _tmp0_;
#line 138 "../src/utils/Recoloring.vala"
	_tmp1_ = opaque;
#line 138 "../src/utils/Recoloring.vala"
	(*_tmp1_).alpha = 1.0f;
#line 140 "../src/utils/Recoloring.vala"
	_tmp2_ = opaque;
#line 140 "../src/utils/Recoloring.vala"
	_tmp3_ = gdk_rgba_to_string (_tmp2_);
#line 140 "../src/utils/Recoloring.vala"
	color_str = _tmp3_;
#line 141 "../src/utils/Recoloring.vala"
	_tmp4_ = color_str;
#line 141 "../src/utils/Recoloring.vala"
	g_string_append_printf (str, "@define-color %s %s;\n", name, _tmp4_);
#line 133 "../src/utils/Recoloring.vala"
	_g_free0 (color_str);
#line 133 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (opaque);
#line 485 "Recoloring.c"
}

/**
     * Define mixed color in CSS string builder
     *
     * @param str CSS string builder
     * @param name color name
     * @param a first color
     * @param b second color
     * @param level mix level
     */
static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 525 "Recoloring.c"
}

void
recoloring_define_color_mixed (GString* str,
                               const gchar* name,
                               GdkRGBA* a,
                               GdkRGBA* b,
                               gdouble level)
{
	gchar* a_str = NULL;
	gchar* _tmp0_;
	gchar* b_str = NULL;
	gchar* _tmp1_;
	gchar* level_string = NULL;
	gchar* _tmp2_;
#line 153 "../src/utils/Recoloring.vala"
	g_return_if_fail (str != NULL);
#line 153 "../src/utils/Recoloring.vala"
	g_return_if_fail (name != NULL);
#line 153 "../src/utils/Recoloring.vala"
	g_return_if_fail (a != NULL);
#line 153 "../src/utils/Recoloring.vala"
	g_return_if_fail (b != NULL);
#line 158 "../src/utils/Recoloring.vala"
	_tmp0_ = gdk_rgba_to_string (a);
#line 158 "../src/utils/Recoloring.vala"
	a_str = _tmp0_;
#line 159 "../src/utils/Recoloring.vala"
	_tmp1_ = gdk_rgba_to_string (b);
#line 159 "../src/utils/Recoloring.vala"
	b_str = _tmp1_;
#line 160 "../src/utils/Recoloring.vala"
	_tmp2_ = double_to_string (level);
#line 160 "../src/utils/Recoloring.vala"
	level_string = _tmp2_;
#line 162 "../src/utils/Recoloring.vala"
	g_string_append_printf (str, "@define-color %s mix(%s, %s, %s);\n", name, a_str, b_str, level_string);
#line 153 "../src/utils/Recoloring.vala"
	_g_free0 (level_string);
#line 153 "../src/utils/Recoloring.vala"
	_g_free0 (b_str);
#line 153 "../src/utils/Recoloring.vala"
	_g_free0 (a_str);
#line 569 "Recoloring.c"
}

/**
     * Get whether style scheme is dark
     *
     * @param scheme style scheme
     *
     * @return whether the style scheme is dark
     */
gboolean
recoloring_is_scheme_dark (GtkSourceStyleScheme* scheme)
{
	gchar* id = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* variant = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GdkRGBA* text_bg = NULL;
	GdkRGBA* _tmp7_;
	GdkRGBA* _tmp8_;
	gboolean result;
#line 178 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (scheme != NULL, FALSE);
#line 179 "../src/utils/Recoloring.vala"
	_tmp0_ = gtk_source_style_scheme_get_id (scheme);
#line 179 "../src/utils/Recoloring.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 179 "../src/utils/Recoloring.vala"
	id = _tmp1_;
#line 180 "../src/utils/Recoloring.vala"
	_tmp2_ = gtk_source_style_scheme_get_metadata (scheme, "variant");
#line 180 "../src/utils/Recoloring.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 180 "../src/utils/Recoloring.vala"
	variant = _tmp3_;
#line 183 "../src/utils/Recoloring.vala"
	_tmp4_ = variant;
#line 183 "../src/utils/Recoloring.vala"
	if (g_strcmp0 (_tmp4_, "light") == 0) {
#line 184 "../src/utils/Recoloring.vala"
		result = FALSE;
#line 184 "../src/utils/Recoloring.vala"
		_g_free0 (variant);
#line 184 "../src/utils/Recoloring.vala"
		_g_free0 (id);
#line 184 "../src/utils/Recoloring.vala"
		return result;
#line 619 "Recoloring.c"
	} else {
		const gchar* _tmp5_;
#line 185 "../src/utils/Recoloring.vala"
		_tmp5_ = variant;
#line 185 "../src/utils/Recoloring.vala"
		if (g_strcmp0 (_tmp5_, "dark") == 0) {
#line 186 "../src/utils/Recoloring.vala"
			result = TRUE;
#line 186 "../src/utils/Recoloring.vala"
			_g_free0 (variant);
#line 186 "../src/utils/Recoloring.vala"
			_g_free0 (id);
#line 186 "../src/utils/Recoloring.vala"
			return result;
#line 634 "Recoloring.c"
		} else {
			const gchar* _tmp6_;
#line 187 "../src/utils/Recoloring.vala"
			_tmp6_ = id;
#line 187 "../src/utils/Recoloring.vala"
			if (g_str_has_suffix (_tmp6_, "-dark")) {
#line 188 "../src/utils/Recoloring.vala"
				result = TRUE;
#line 188 "../src/utils/Recoloring.vala"
				_g_free0 (variant);
#line 188 "../src/utils/Recoloring.vala"
				_g_free0 (id);
#line 188 "../src/utils/Recoloring.vala"
				return result;
#line 649 "Recoloring.c"
			}
		}
	}
#line 190 "../src/utils/Recoloring.vala"
	_tmp7_ = recoloring_get_color (scheme, "text", RECOLORING_COLOR_KIND_BACKGROUND);
#line 190 "../src/utils/Recoloring.vala"
	text_bg = _tmp7_;
#line 191 "../src/utils/Recoloring.vala"
	_tmp8_ = text_bg;
#line 191 "../src/utils/Recoloring.vala"
	if (_tmp8_ != NULL) {
#line 661 "Recoloring.c"
		gdouble r = 0.0;
		GdkRGBA* _tmp9_;
		gdouble g = 0.0;
		GdkRGBA* _tmp10_;
		gdouble b = 0.0;
		GdkRGBA* _tmp11_;
		gdouble hsp = 0.0;
#line 193 "../src/utils/Recoloring.vala"
		_tmp9_ = text_bg;
#line 193 "../src/utils/Recoloring.vala"
		r = (*_tmp9_).red * 255.0;
#line 194 "../src/utils/Recoloring.vala"
		_tmp10_ = text_bg;
#line 194 "../src/utils/Recoloring.vala"
		g = (*_tmp10_).green * 255.0;
#line 195 "../src/utils/Recoloring.vala"
		_tmp11_ = text_bg;
#line 195 "../src/utils/Recoloring.vala"
		b = (*_tmp11_).blue * 255.0;
#line 196 "../src/utils/Recoloring.vala"
		hsp = sqrt (((0.299 * (r * r)) + (0.587 * (g * g))) + (0.114 * (b * b)));
#line 200 "../src/utils/Recoloring.vala"
		result = hsp <= 127.5;
#line 200 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (text_bg);
#line 200 "../src/utils/Recoloring.vala"
		_g_free0 (variant);
#line 200 "../src/utils/Recoloring.vala"
		_g_free0 (id);
#line 200 "../src/utils/Recoloring.vala"
		return result;
#line 693 "Recoloring.c"
	}
#line 203 "../src/utils/Recoloring.vala"
	result = FALSE;
#line 203 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (text_bg);
#line 203 "../src/utils/Recoloring.vala"
	_g_free0 (variant);
#line 203 "../src/utils/Recoloring.vala"
	_g_free0 (id);
#line 203 "../src/utils/Recoloring.vala"
	return result;
#line 705 "Recoloring.c"
}

/**
     * Generate CSS for style scheme
     *
     * This function is used to apply `gtksourceview`'s
     * style schemes to whole application.
     *
     * @param style_scheme style scheme
     *
     * @return CSS string to apply on application
     */
gchar*
recoloring_generate_css (GtkSourceStyleScheme* style_scheme)
{
	GdkRGBA black = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA white = {0};
	GdkRGBA _tmp1_ = {0};
	gchar* id = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* name = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean is_dark = FALSE;
	GdkRGBA _tmp8_ = {0};
	GdkRGBA alt = {0};
	GString* str = NULL;
	GString* _tmp11_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	GdkRGBA* _tmp14_ = NULL;
	GdkRGBA* _tmp15_;
	GdkRGBA* text_bg = NULL;
	GdkRGBA* _tmp20_;
	GdkRGBA* _tmp21_ = NULL;
	GdkRGBA* _tmp22_;
	GdkRGBA* text_fg = NULL;
	GdkRGBA* _tmp27_;
	GdkRGBA* _tmp28_ = NULL;
	GdkRGBA* _tmp29_;
	GdkRGBA* right_margin = NULL;
	GdkRGBA* _tmp32_;
	GdkRGBA* _tmp33_;
	GString* _tmp42_;
	GdkRGBA* _tmp43_;
	GdkRGBA _tmp44_;
	GdkRGBA _tmp45_;
	GString* _tmp46_;
	GdkRGBA* _tmp47_;
	GdkRGBA _tmp48_;
	GdkRGBA _tmp49_;
	GString* _tmp50_;
	GdkRGBA* _tmp51_;
	gdouble _tmp52_ = 0.0;
	GString* _tmp53_;
	GdkRGBA* _tmp54_;
	GdkRGBA _tmp55_;
	GdkRGBA _tmp56_;
	GString* _tmp57_;
	GdkRGBA* _tmp58_;
	GdkRGBA* _tmp59_ = NULL;
	GdkRGBA* _tmp60_;
	GString* _tmp62_;
	GdkRGBA* _tmp63_ = NULL;
	GdkRGBA* _tmp64_;
	GString* _tmp66_;
	GdkRGBA* accent_color = NULL;
	GdkRGBA* _tmp67_;
	GdkRGBA* _tmp68_;
	GString* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* result;
#line 216 "../src/utils/Recoloring.vala"
	g_return_val_if_fail (style_scheme != NULL, NULL);
#line 217 "../src/utils/Recoloring.vala"
	_tmp0_.red = (gfloat) 0;
#line 217 "../src/utils/Recoloring.vala"
	_tmp0_.green = (gfloat) 0;
#line 217 "../src/utils/Recoloring.vala"
	_tmp0_.blue = (gfloat) 0;
#line 217 "../src/utils/Recoloring.vala"
	_tmp0_.alpha = (gfloat) 1;
#line 217 "../src/utils/Recoloring.vala"
	black = _tmp0_;
#line 218 "../src/utils/Recoloring.vala"
	_tmp1_.red = (gfloat) 1;
#line 218 "../src/utils/Recoloring.vala"
	_tmp1_.green = (gfloat) 1;
#line 218 "../src/utils/Recoloring.vala"
	_tmp1_.blue = (gfloat) 1;
#line 218 "../src/utils/Recoloring.vala"
	_tmp1_.alpha = (gfloat) 1;
#line 218 "../src/utils/Recoloring.vala"
	white = _tmp1_;
#line 221 "../src/utils/Recoloring.vala"
	_tmp2_ = gtk_source_style_scheme_get_name (style_scheme);
#line 221 "../src/utils/Recoloring.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 221 "../src/utils/Recoloring.vala"
	id = _tmp3_;
#line 222 "../src/utils/Recoloring.vala"
	_tmp4_ = id;
#line 222 "../src/utils/Recoloring.vala"
	if (g_str_has_prefix (_tmp4_, "Adwaita")) {
#line 814 "Recoloring.c"
		gchar* _tmp5_;
#line 223 "../src/utils/Recoloring.vala"
		_tmp5_ = g_strdup ("");
#line 223 "../src/utils/Recoloring.vala"
		result = _tmp5_;
#line 223 "../src/utils/Recoloring.vala"
		_g_free0 (id);
#line 223 "../src/utils/Recoloring.vala"
		return result;
#line 824 "Recoloring.c"
	}
#line 225 "../src/utils/Recoloring.vala"
	_tmp6_ = gtk_source_style_scheme_get_name (style_scheme);
#line 225 "../src/utils/Recoloring.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 225 "../src/utils/Recoloring.vala"
	name = _tmp7_;
#line 226 "../src/utils/Recoloring.vala"
	is_dark = recoloring_is_scheme_dark (style_scheme);
#line 227 "../src/utils/Recoloring.vala"
	if (is_dark) {
#line 836 "Recoloring.c"
		GdkRGBA _tmp9_;
#line 227 "../src/utils/Recoloring.vala"
		_tmp9_ = white;
#line 227 "../src/utils/Recoloring.vala"
		_tmp8_ = _tmp9_;
#line 842 "Recoloring.c"
	} else {
		GdkRGBA _tmp10_;
#line 227 "../src/utils/Recoloring.vala"
		_tmp10_ = black;
#line 227 "../src/utils/Recoloring.vala"
		_tmp8_ = _tmp10_;
#line 849 "Recoloring.c"
	}
#line 227 "../src/utils/Recoloring.vala"
	alt = _tmp8_;
#line 229 "../src/utils/Recoloring.vala"
	_tmp11_ = g_string_new (SHARED_CSS);
#line 229 "../src/utils/Recoloring.vala"
	str = _tmp11_;
#line 230 "../src/utils/Recoloring.vala"
	_tmp12_ = str;
#line 230 "../src/utils/Recoloring.vala"
	_tmp13_ = name;
#line 230 "../src/utils/Recoloring.vala"
	g_string_append_printf (_tmp12_, "/* %s */\n", _tmp13_);
#line 234 "../src/utils/Recoloring.vala"
	_tmp15_ = recoloring_get_color (style_scheme, "text", RECOLORING_COLOR_KIND_BACKGROUND);
#line 234 "../src/utils/Recoloring.vala"
	_tmp14_ = _tmp15_;
#line 234 "../src/utils/Recoloring.vala"
	if (_tmp14_ == NULL) {
#line 869 "Recoloring.c"
		GdkRGBA _tmp16_ = {0};
		GdkRGBA* _tmp19_;
#line 235 "../src/utils/Recoloring.vala"
		if (is_dark) {
#line 874 "Recoloring.c"
			GdkRGBA _tmp17_;
#line 236 "../src/utils/Recoloring.vala"
			_tmp17_ = black;
#line 236 "../src/utils/Recoloring.vala"
			_tmp16_ = _tmp17_;
#line 880 "Recoloring.c"
		} else {
			GdkRGBA _tmp18_;
#line 237 "../src/utils/Recoloring.vala"
			_tmp18_ = white;
#line 237 "../src/utils/Recoloring.vala"
			_tmp16_ = _tmp18_;
#line 887 "Recoloring.c"
		}
#line 235 "../src/utils/Recoloring.vala"
		_tmp19_ = __vala_GdkRGBA_copy0 (&_tmp16_);
#line 235 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp14_);
#line 235 "../src/utils/Recoloring.vala"
		_tmp14_ = _tmp19_;
#line 895 "Recoloring.c"
	}
#line 234 "../src/utils/Recoloring.vala"
	_tmp20_ = _tmp14_;
#line 234 "../src/utils/Recoloring.vala"
	_tmp14_ = NULL;
#line 234 "../src/utils/Recoloring.vala"
	text_bg = _tmp20_;
#line 239 "../src/utils/Recoloring.vala"
	_tmp22_ = recoloring_get_color (style_scheme, "text", RECOLORING_COLOR_KIND_FOREGROUND);
#line 239 "../src/utils/Recoloring.vala"
	_tmp21_ = _tmp22_;
#line 239 "../src/utils/Recoloring.vala"
	if (_tmp21_ == NULL) {
#line 909 "Recoloring.c"
		GdkRGBA _tmp23_ = {0};
		GdkRGBA* _tmp26_;
#line 240 "../src/utils/Recoloring.vala"
		if (is_dark) {
#line 914 "Recoloring.c"
			GdkRGBA _tmp24_;
#line 241 "../src/utils/Recoloring.vala"
			_tmp24_ = white;
#line 241 "../src/utils/Recoloring.vala"
			_tmp23_ = _tmp24_;
#line 920 "Recoloring.c"
		} else {
			GdkRGBA _tmp25_;
#line 242 "../src/utils/Recoloring.vala"
			_tmp25_ = black;
#line 242 "../src/utils/Recoloring.vala"
			_tmp23_ = _tmp25_;
#line 927 "Recoloring.c"
		}
#line 240 "../src/utils/Recoloring.vala"
		_tmp26_ = __vala_GdkRGBA_copy0 (&_tmp23_);
#line 240 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp21_);
#line 240 "../src/utils/Recoloring.vala"
		_tmp21_ = _tmp26_;
#line 935 "Recoloring.c"
	}
#line 239 "../src/utils/Recoloring.vala"
	_tmp27_ = _tmp21_;
#line 239 "../src/utils/Recoloring.vala"
	_tmp21_ = NULL;
#line 239 "../src/utils/Recoloring.vala"
	text_fg = _tmp27_;
#line 244 "../src/utils/Recoloring.vala"
	_tmp29_ = recoloring_get_color (style_scheme, "right-margin", RECOLORING_COLOR_KIND_BACKGROUND);
#line 244 "../src/utils/Recoloring.vala"
	_tmp28_ = _tmp29_;
#line 244 "../src/utils/Recoloring.vala"
	if (_tmp28_ == NULL) {
#line 949 "Recoloring.c"
		GdkRGBA* _tmp30_;
		GdkRGBA* _tmp31_;
#line 245 "../src/utils/Recoloring.vala"
		_tmp30_ = text_bg;
#line 245 "../src/utils/Recoloring.vala"
		_tmp31_ = __vala_GdkRGBA_copy0 (_tmp30_);
#line 245 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp28_);
#line 245 "../src/utils/Recoloring.vala"
		_tmp28_ = _tmp31_;
#line 960 "Recoloring.c"
	}
#line 244 "../src/utils/Recoloring.vala"
	_tmp32_ = _tmp28_;
#line 244 "../src/utils/Recoloring.vala"
	_tmp28_ = NULL;
#line 244 "../src/utils/Recoloring.vala"
	right_margin = _tmp32_;
#line 246 "../src/utils/Recoloring.vala"
	_tmp33_ = right_margin;
#line 246 "../src/utils/Recoloring.vala"
	(*_tmp33_).alpha = (gfloat) 1;
#line 248 "../src/utils/Recoloring.vala"
	if (is_dark) {
#line 974 "Recoloring.c"
		GString* _tmp34_;
		GdkRGBA* _tmp35_;
		GdkRGBA _tmp36_;
		GdkRGBA _tmp37_;
#line 249 "../src/utils/Recoloring.vala"
		_tmp34_ = str;
#line 249 "../src/utils/Recoloring.vala"
		_tmp35_ = text_bg;
#line 249 "../src/utils/Recoloring.vala"
		_tmp36_ = alt;
#line 249 "../src/utils/Recoloring.vala"
		_tmp37_ = *_tmp35_;
#line 249 "../src/utils/Recoloring.vala"
		recoloring_define_color_mixed (_tmp34_, "window_bg_color", &_tmp37_, &_tmp36_, 0.025);
#line 989 "Recoloring.c"
	} else {
		GString* _tmp38_;
		GdkRGBA* _tmp39_;
		GdkRGBA _tmp40_;
		GdkRGBA _tmp41_;
#line 251 "../src/utils/Recoloring.vala"
		_tmp38_ = str;
#line 251 "../src/utils/Recoloring.vala"
		_tmp39_ = text_bg;
#line 251 "../src/utils/Recoloring.vala"
		_tmp40_ = white;
#line 251 "../src/utils/Recoloring.vala"
		_tmp41_ = *_tmp39_;
#line 251 "../src/utils/Recoloring.vala"
		recoloring_define_color_mixed (_tmp38_, "window_bg_color", &_tmp41_, &_tmp40_, 0.1);
#line 1005 "Recoloring.c"
	}
#line 253 "../src/utils/Recoloring.vala"
	_tmp42_ = str;
#line 253 "../src/utils/Recoloring.vala"
	_tmp43_ = text_bg;
#line 253 "../src/utils/Recoloring.vala"
	_tmp44_ = alt;
#line 253 "../src/utils/Recoloring.vala"
	_tmp45_ = *_tmp43_;
#line 253 "../src/utils/Recoloring.vala"
	recoloring_define_color_mixed (_tmp42_, "headerbar_bg_color", &_tmp45_, &_tmp44_, 0.05);
#line 255 "../src/utils/Recoloring.vala"
	_tmp46_ = str;
#line 255 "../src/utils/Recoloring.vala"
	_tmp47_ = text_fg;
#line 255 "../src/utils/Recoloring.vala"
	_tmp48_ = alt;
#line 255 "../src/utils/Recoloring.vala"
	_tmp49_ = *_tmp47_;
#line 255 "../src/utils/Recoloring.vala"
	recoloring_define_color_mixed (_tmp46_, "window_fg_color", &_tmp49_, &_tmp48_, 0.1);
#line 256 "../src/utils/Recoloring.vala"
	_tmp50_ = str;
#line 256 "../src/utils/Recoloring.vala"
	_tmp51_ = text_fg;
#line 256 "../src/utils/Recoloring.vala"
	recoloring_define_color (_tmp50_, "headerbar_fg_color", _tmp51_);
#line 258 "../src/utils/Recoloring.vala"
	if (is_dark) {
#line 258 "../src/utils/Recoloring.vala"
		_tmp52_ = 0.1;
#line 1037 "Recoloring.c"
	} else {
#line 258 "../src/utils/Recoloring.vala"
		_tmp52_ = 0.3;
#line 1041 "Recoloring.c"
	}
#line 258 "../src/utils/Recoloring.vala"
	_tmp53_ = str;
#line 258 "../src/utils/Recoloring.vala"
	_tmp54_ = text_bg;
#line 258 "../src/utils/Recoloring.vala"
	_tmp55_ = white;
#line 258 "../src/utils/Recoloring.vala"
	_tmp56_ = *_tmp54_;
#line 258 "../src/utils/Recoloring.vala"
	recoloring_define_color_mixed (_tmp53_, "view_bg_color", &_tmp56_, &_tmp55_, _tmp52_);
#line 259 "../src/utils/Recoloring.vala"
	_tmp57_ = str;
#line 259 "../src/utils/Recoloring.vala"
	_tmp58_ = text_fg;
#line 259 "../src/utils/Recoloring.vala"
	recoloring_define_color (_tmp57_, "view_fg_color", _tmp58_);
#line 265 "../src/utils/Recoloring.vala"
	_tmp60_ = recoloring_get_metadata_color (style_scheme, "accent_bg_color");
#line 265 "../src/utils/Recoloring.vala"
	_tmp59_ = _tmp60_;
#line 265 "../src/utils/Recoloring.vala"
	if (_tmp59_ == NULL) {
#line 1065 "Recoloring.c"
		GdkRGBA* _tmp61_;
#line 266 "../src/utils/Recoloring.vala"
		_tmp61_ = recoloring_get_color (style_scheme, "selection", RECOLORING_COLOR_KIND_BACKGROUND);
#line 266 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp59_);
#line 266 "../src/utils/Recoloring.vala"
		_tmp59_ = _tmp61_;
#line 1073 "Recoloring.c"
	}
#line 262 "../src/utils/Recoloring.vala"
	_tmp62_ = str;
#line 262 "../src/utils/Recoloring.vala"
	recoloring_define_color (_tmp62_, "accent_bg_color", _tmp59_);
#line 272 "../src/utils/Recoloring.vala"
	_tmp64_ = recoloring_get_metadata_color (style_scheme, "accent_fg_color");
#line 272 "../src/utils/Recoloring.vala"
	_tmp63_ = _tmp64_;
#line 272 "../src/utils/Recoloring.vala"
	if (_tmp63_ == NULL) {
#line 1085 "Recoloring.c"
		GdkRGBA* _tmp65_;
#line 273 "../src/utils/Recoloring.vala"
		_tmp65_ = recoloring_get_color (style_scheme, "selection", RECOLORING_COLOR_KIND_FOREGROUND);
#line 273 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp63_);
#line 273 "../src/utils/Recoloring.vala"
		_tmp63_ = _tmp65_;
#line 1093 "Recoloring.c"
	}
#line 269 "../src/utils/Recoloring.vala"
	_tmp66_ = str;
#line 269 "../src/utils/Recoloring.vala"
	recoloring_define_color (_tmp66_, "accent_fg_color", _tmp63_);
#line 276 "../src/utils/Recoloring.vala"
	_tmp67_ = recoloring_get_metadata_color (style_scheme, "accent_color");
#line 276 "../src/utils/Recoloring.vala"
	accent_color = _tmp67_;
#line 277 "../src/utils/Recoloring.vala"
	_tmp68_ = accent_color;
#line 277 "../src/utils/Recoloring.vala"
	if (_tmp68_ != NULL) {
#line 1107 "Recoloring.c"
		GString* _tmp69_;
		GdkRGBA* _tmp70_;
#line 278 "../src/utils/Recoloring.vala"
		_tmp69_ = str;
#line 278 "../src/utils/Recoloring.vala"
		_tmp70_ = accent_color;
#line 278 "../src/utils/Recoloring.vala"
		recoloring_define_color (_tmp69_, "accent_color", _tmp70_);
#line 1116 "Recoloring.c"
	} else {
		GdkRGBA* _tmp71_ = NULL;
		GdkRGBA* _tmp72_;
		GdkRGBA* _tmp74_;
		GdkRGBA* _tmp75_;
#line 280 "../src/utils/Recoloring.vala"
		_tmp72_ = recoloring_get_metadata_color (style_scheme, "accent_bg_color");
#line 280 "../src/utils/Recoloring.vala"
		_tmp71_ = _tmp72_;
#line 280 "../src/utils/Recoloring.vala"
		if (_tmp71_ == NULL) {
#line 1128 "Recoloring.c"
			GdkRGBA* _tmp73_;
#line 281 "../src/utils/Recoloring.vala"
			_tmp73_ = recoloring_get_color (style_scheme, "selection", RECOLORING_COLOR_KIND_BACKGROUND);
#line 281 "../src/utils/Recoloring.vala"
			__vala_GdkRGBA_free0 (_tmp71_);
#line 281 "../src/utils/Recoloring.vala"
			_tmp71_ = _tmp73_;
#line 1136 "Recoloring.c"
		}
#line 280 "../src/utils/Recoloring.vala"
		_tmp74_ = _tmp71_;
#line 280 "../src/utils/Recoloring.vala"
		_tmp71_ = NULL;
#line 280 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (accent_color);
#line 280 "../src/utils/Recoloring.vala"
		accent_color = _tmp74_;
#line 283 "../src/utils/Recoloring.vala"
		_tmp75_ = accent_color;
#line 283 "../src/utils/Recoloring.vala"
		if (_tmp75_ != NULL) {
#line 1150 "Recoloring.c"
			GdkRGBA* _tmp76_;
			GString* _tmp77_;
			GdkRGBA* _tmp78_;
			GdkRGBA _tmp79_;
			GdkRGBA _tmp80_;
#line 284 "../src/utils/Recoloring.vala"
			_tmp76_ = accent_color;
#line 284 "../src/utils/Recoloring.vala"
			(*_tmp76_).alpha = (gfloat) 1;
#line 285 "../src/utils/Recoloring.vala"
			_tmp77_ = str;
#line 285 "../src/utils/Recoloring.vala"
			_tmp78_ = accent_color;
#line 285 "../src/utils/Recoloring.vala"
			_tmp79_ = alt;
#line 285 "../src/utils/Recoloring.vala"
			_tmp80_ = *_tmp78_;
#line 285 "../src/utils/Recoloring.vala"
			recoloring_define_color_mixed (_tmp77_, "accent_color", &_tmp80_, &_tmp79_, 0.1);
#line 1170 "Recoloring.c"
		}
#line 277 "../src/utils/Recoloring.vala"
		__vala_GdkRGBA_free0 (_tmp71_);
#line 1174 "Recoloring.c"
	}
#line 289 "../src/utils/Recoloring.vala"
	if (is_dark) {
#line 1178 "Recoloring.c"
		GString* _tmp81_;
#line 290 "../src/utils/Recoloring.vala"
		_tmp81_ = str;
#line 290 "../src/utils/Recoloring.vala"
		g_string_append (_tmp81_, DARK_CSS_SUFFIX);
#line 1184 "Recoloring.c"
	} else {
		GString* _tmp82_;
#line 292 "../src/utils/Recoloring.vala"
		_tmp82_ = str;
#line 292 "../src/utils/Recoloring.vala"
		g_string_append (_tmp82_, LIGHT_CSS_SUFFIX);
#line 1191 "Recoloring.c"
	}
#line 294 "../src/utils/Recoloring.vala"
	_tmp83_ = str;
#line 294 "../src/utils/Recoloring.vala"
	_tmp84_ = _tmp83_->str;
#line 294 "../src/utils/Recoloring.vala"
	_tmp85_ = g_strdup (_tmp84_);
#line 294 "../src/utils/Recoloring.vala"
	result = _tmp85_;
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (accent_color);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (_tmp63_);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (_tmp59_);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (right_margin);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (_tmp28_);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (text_fg);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (_tmp21_);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (text_bg);
#line 294 "../src/utils/Recoloring.vala"
	__vala_GdkRGBA_free0 (_tmp14_);
#line 294 "../src/utils/Recoloring.vala"
	_g_string_free0 (str);
#line 294 "../src/utils/Recoloring.vala"
	_g_free0 (name);
#line 294 "../src/utils/Recoloring.vala"
	_g_free0 (id);
#line 294 "../src/utils/Recoloring.vala"
	return result;
#line 1227 "Recoloring.c"
}

