/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Copyright 2021 Gleb Smirnov <glebsmirnov0708@gmail.com>*/
/* SPDX-FileCopyrightText: 2021 Gleb Smirnov <glebsmirnov0708@gmail.com>*/
/**/
/* SPDX-License-Identifier: GPL-3.0-or-later*/

#include <gio/gio.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TextPiecesUtilsEnsureDirectoryExistsData TextPiecesUtilsEnsureDirectoryExistsData;

struct _TextPiecesUtilsEnsureDirectoryExistsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GFile* dir;
	GFile* parent_dir;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_;
};

static void text_pieces_utils_ensure_directory_exists_data_free (gpointer _data);
VALA_EXTERN void text_pieces_utils_ensure_directory_exists (GFile* dir,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void text_pieces_utils_ensure_directory_exists_finish (GAsyncResult* _res_,
                                                       GError** error);
static gboolean text_pieces_utils_ensure_directory_exists_co (TextPiecesUtilsEnsureDirectoryExistsData* _data_);
static void text_pieces_utils_ensure_directory_exists_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);

static void
text_pieces_utils_ensure_directory_exists_data_free (gpointer _data)
{
	TextPiecesUtilsEnsureDirectoryExistsData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->dir);
	g_slice_free (TextPiecesUtilsEnsureDirectoryExistsData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
text_pieces_utils_ensure_directory_exists (GFile* dir,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	TextPiecesUtilsEnsureDirectoryExistsData* _data_;
	GFile* _tmp0_;
	g_return_if_fail (dir != NULL);
	_data_ = g_slice_new0 (TextPiecesUtilsEnsureDirectoryExistsData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, text_pieces_utils_ensure_directory_exists_data_free);
	_tmp0_ = _g_object_ref0 (dir);
	_g_object_unref0 (_data_->dir);
	_data_->dir = _tmp0_;
	text_pieces_utils_ensure_directory_exists_co (_data_);
}

void
text_pieces_utils_ensure_directory_exists_finish (GAsyncResult* _res_,
                                                  GError** error)
{
	TextPiecesUtilsEnsureDirectoryExistsData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

/**
     * Create directory if not exists
     *
     * @param dir directory to ensure
     */
static void
text_pieces_utils_ensure_directory_exists_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	TextPiecesUtilsEnsureDirectoryExistsData* _data_;
#line 20 "../src/utils/Utils.vala"
	_data_ = _user_data_;
#line 20 "../src/utils/Utils.vala"
	_data_->_source_object_ = source_object;
#line 20 "../src/utils/Utils.vala"
	_data_->_res_ = _res_;
#line 20 "../src/utils/Utils.vala"
	text_pieces_utils_ensure_directory_exists_co (_data_);
#line 120 "Utils.c"
}

static gboolean
text_pieces_utils_ensure_directory_exists_co (TextPiecesUtilsEnsureDirectoryExistsData* _data_)
{
#line 12 "../src/utils/Utils.vala"
	switch (_data_->_state_) {
#line 12 "../src/utils/Utils.vala"
		case 0:
#line 130 "Utils.c"
		goto _state_0;
#line 12 "../src/utils/Utils.vala"
		case 1:
#line 134 "Utils.c"
		goto _state_1;
#line 12 "../src/utils/Utils.vala"
		case 2:
#line 138 "Utils.c"
		goto _state_2;
		default:
#line 12 "../src/utils/Utils.vala"
		g_assert_not_reached ();
#line 143 "Utils.c"
	}
	_state_0:
#line 15 "../src/utils/Utils.vala"
	_data_->_tmp0_ = g_file_get_parent (_data_->dir);
#line 15 "../src/utils/Utils.vala"
	_data_->parent_dir = _data_->_tmp0_;
#line 19 "../src/utils/Utils.vala"
	_data_->_tmp1_ = _data_->parent_dir;
#line 19 "../src/utils/Utils.vala"
	if (!g_file_query_exists (_data_->_tmp1_, NULL)) {
#line 20 "../src/utils/Utils.vala"
		_data_->_tmp2_ = _data_->parent_dir;
#line 20 "../src/utils/Utils.vala"
		_data_->_state_ = 1;
#line 20 "../src/utils/Utils.vala"
		text_pieces_utils_ensure_directory_exists (_data_->_tmp2_, text_pieces_utils_ensure_directory_exists_ready, _data_);
#line 20 "../src/utils/Utils.vala"
		return FALSE;
#line 162 "Utils.c"
		_state_1:
#line 20 "../src/utils/Utils.vala"
		text_pieces_utils_ensure_directory_exists_finish (_data_->_res_, &_data_->_inner_error0_);
#line 20 "../src/utils/Utils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 20 "../src/utils/Utils.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 20 "../src/utils/Utils.vala"
			_g_object_unref0 (_data_->parent_dir);
#line 20 "../src/utils/Utils.vala"
			g_object_unref (_data_->_async_result);
#line 20 "../src/utils/Utils.vala"
			return FALSE;
#line 176 "Utils.c"
		}
	}
#line 24 "../src/utils/Utils.vala"
	if (!g_file_query_exists (_data_->dir, NULL)) {
#line 25 "../src/utils/Utils.vala"
		_data_->_state_ = 2;
#line 25 "../src/utils/Utils.vala"
		g_file_make_directory_async (_data_->dir, G_PRIORITY_DEFAULT, NULL, text_pieces_utils_ensure_directory_exists_ready, _data_);
#line 25 "../src/utils/Utils.vala"
		return FALSE;
#line 187 "Utils.c"
		_state_2:
#line 25 "../src/utils/Utils.vala"
		g_file_make_directory_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 25 "../src/utils/Utils.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 25 "../src/utils/Utils.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 25 "../src/utils/Utils.vala"
			_g_object_unref0 (_data_->parent_dir);
#line 25 "../src/utils/Utils.vala"
			g_object_unref (_data_->_async_result);
#line 25 "../src/utils/Utils.vala"
			return FALSE;
#line 201 "Utils.c"
		}
	}
#line 12 "../src/utils/Utils.vala"
	_g_object_unref0 (_data_->parent_dir);
#line 12 "../src/utils/Utils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 12 "../src/utils/Utils.vala"
	if (_data_->_state_ != 0) {
#line 12 "../src/utils/Utils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 12 "../src/utils/Utils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 214 "Utils.c"
		}
	}
#line 12 "../src/utils/Utils.vala"
	g_object_unref (_data_->_async_result);
#line 12 "../src/utils/Utils.vala"
	return FALSE;
#line 221 "Utils.c"
}

