/* Search.c generated by valac 0.56.17, the Vala compiler
 * generated from Search.vala, do not modify */

/* SPDX-FileCopyrightText: 2022 Gleb Smirnov <glebsmirnov0708@gmail.com>*/
/**/
/* SPDX-License-Identifier: GPL-3.0-or-later*/

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TEXT_PIECES_TYPE_SEARCH (text_pieces_search_get_type ())
#define TEXT_PIECES_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TEXT_PIECES_TYPE_SEARCH, TextPiecesSearch))
#define TEXT_PIECES_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TEXT_PIECES_TYPE_SEARCH, TextPiecesSearchClass))
#define TEXT_PIECES_IS_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TEXT_PIECES_TYPE_SEARCH))
#define TEXT_PIECES_IS_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TEXT_PIECES_TYPE_SEARCH))
#define TEXT_PIECES_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TEXT_PIECES_TYPE_SEARCH, TextPiecesSearchClass))

typedef struct _TextPiecesSearch TextPiecesSearch;
typedef struct _TextPiecesSearchClass TextPiecesSearchClass;
typedef struct _TextPiecesSearchPrivate TextPiecesSearchPrivate;
enum  {
	TEXT_PIECES_SEARCH_0_PROPERTY,
	TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY,
	TEXT_PIECES_SEARCH_NUM_PROPERTIES
};
static GParamSpec* text_pieces_search_properties[TEXT_PIECES_SEARCH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define TEXT_PIECES_TYPE_TOOL (text_pieces_tool_get_type ())
#define TEXT_PIECES_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TEXT_PIECES_TYPE_TOOL, TextPiecesTool))
#define TEXT_PIECES_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TEXT_PIECES_TYPE_TOOL, TextPiecesToolClass))
#define TEXT_PIECES_IS_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TEXT_PIECES_TYPE_TOOL))
#define TEXT_PIECES_IS_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TEXT_PIECES_TYPE_TOOL))
#define TEXT_PIECES_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TEXT_PIECES_TYPE_TOOL, TextPiecesToolClass))

typedef struct _TextPiecesTool TextPiecesTool;
typedef struct _TextPiecesToolClass TextPiecesToolClass;

#define TEXT_PIECES_TYPE_TOOLS_CONTROLLER (text_pieces_tools_controller_get_type ())
#define TEXT_PIECES_TOOLS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TEXT_PIECES_TYPE_TOOLS_CONTROLLER, TextPiecesToolsController))
#define TEXT_PIECES_TOOLS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TEXT_PIECES_TYPE_TOOLS_CONTROLLER, TextPiecesToolsControllerClass))
#define TEXT_PIECES_IS_TOOLS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TEXT_PIECES_TYPE_TOOLS_CONTROLLER))
#define TEXT_PIECES_IS_TOOLS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TEXT_PIECES_TYPE_TOOLS_CONTROLLER))
#define TEXT_PIECES_TOOLS_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TEXT_PIECES_TYPE_TOOLS_CONTROLLER, TextPiecesToolsControllerClass))

typedef struct _TextPiecesToolsController TextPiecesToolsController;
typedef struct _TextPiecesToolsControllerClass TextPiecesToolsControllerClass;
enum  {
	TEXT_PIECES_SEARCH_TOOL_SELECTED_SIGNAL,
	TEXT_PIECES_SEARCH_NUM_SIGNALS
};
static guint text_pieces_search_signals[TEXT_PIECES_SEARCH_NUM_SIGNALS] = {0};

struct _TextPiecesSearch {
	AdwBin parent_instance;
	TextPiecesSearchPrivate * priv;
};

struct _TextPiecesSearchClass {
	AdwBinClass parent_class;
};

struct _TextPiecesSearchPrivate {
	GtkViewport* results_viewport;
	GtkListBox* results_listbox;
	GtkStack* search_stack;
	GtkSearchEntry* _search_entry;
	GListModel* results_model;
	GtkSorter* sorter;
	GtkFilter* filter;
	GtkEventControllerKey* search_event_controller;
};

static gint TextPiecesSearch_private_offset;
static gpointer text_pieces_search_parent_class = NULL;
VALA_EXTERN TextPiecesToolsController* text_pieces_application_tools;

VALA_EXTERN GType text_pieces_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TextPiecesSearch, g_object_unref)
VALA_EXTERN void text_pieces_search_reset (TextPiecesSearch* self);
VALA_EXTERN GtkSearchEntry* text_pieces_search_get_search_entry (TextPiecesSearch* self);
static void text_pieces_search_activate_selected_result (TextPiecesSearch* self);
static gboolean text_pieces_search_on_search_entry_key (TextPiecesSearch* self,
                                                 guint keyval,
                                                 guint keycode,
                                                 GdkModifierType modifiers);
static gboolean* _bool_dup (gboolean* self);
static void text_pieces_search_on_row_activated (TextPiecesSearch* self,
                                          GtkListBoxRow* row);
VALA_EXTERN GType text_pieces_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TextPiecesTool, g_object_unref)
static void _text_pieces_search_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                      GtkListBoxRow* row,
                                                                      gpointer self);
static void text_pieces_search_update_search_results (TextPiecesSearch* self);
VALA_EXTERN gint text_pieces_search_tool_sort_func (TextPiecesSearch* self,
                                        TextPiecesTool* a,
                                        TextPiecesTool* b);
static gint text_pieces_search_calculate_irrelevance (TextPiecesTool* tool,
                                               const gchar* query);
VALA_EXTERN const gchar* text_pieces_tool_get_translated_name (TextPiecesTool* self);
VALA_EXTERN gboolean text_pieces_search_tool_filter_func (TextPiecesSearch* self,
                                              GObject* tool);
static gint text_pieces_search_calculate_irrelevance_for_fields (gchar** fields,
                                                          gint fields_length1,
                                                          const gchar* query);
VALA_EXTERN const gchar* text_pieces_tool_get_name (TextPiecesTool* self);
VALA_EXTERN const gchar* text_pieces_tool_get_description (TextPiecesTool* self);
VALA_EXTERN const gchar* text_pieces_tool_get_translated_description (TextPiecesTool* self);
VALA_EXTERN TextPiecesSearch* text_pieces_search_new (void);
VALA_EXTERN TextPiecesSearch* text_pieces_search_construct (GType object_type);
static void text_pieces_search_set_search_entry (TextPiecesSearch* self,
                                          GtkSearchEntry* value);
static GObject * text_pieces_search_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static gint _text_pieces_search___lambda18_ (TextPiecesSearch* self,
                                      gconstpointer a,
                                      gconstpointer b);
static gint __text_pieces_search___lambda18__gcompare_data_func (gconstpointer a,
                                                          gconstpointer b,
                                                          gpointer self);
static gboolean _text_pieces_search_tool_filter_func_gtk_custom_filter_func (GObject* item,
                                                                      gpointer self);
VALA_EXTERN GType text_pieces_tools_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TextPiecesToolsController, g_object_unref)
VALA_EXTERN GListStore* text_pieces_tools_controller_get_all_tools (TextPiecesToolsController* self);
VALA_EXTERN GtkWidget* text_pieces_build_list_row (GObject* item);
static GtkWidget* _text_pieces_build_list_row_gtk_list_box_create_widget_func (GObject* item,
                                                                        gpointer self);
static void _text_pieces_search_update_search_results_gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self);
static void _text_pieces_search_activate_selected_result_gtk_search_entry_activate (GtkSearchEntry* _sender,
                                                                             gpointer self);
static gboolean _text_pieces_search_on_search_entry_key_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                       guint keyval,
                                                                                       guint keycode,
                                                                                       GdkModifierType state,
                                                                                       gpointer self);
static void text_pieces_search_finalize (GObject * obj);
static GType text_pieces_search_get_type_once (void);
static void _vala_text_pieces_search_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_text_pieces_search_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
text_pieces_search_get_instance_private (TextPiecesSearch* self)
{
	return G_STRUCT_MEMBER_P (self, TextPiecesSearch_private_offset);
}

/**
     * Reset search
     *
     * Clear the search entry, scroll to the top, reset selection
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/widgets/Search.vala"
	return self ? g_object_ref (self) : NULL;
#line 202 "Search.c"
}

void
text_pieces_search_reset (TextPiecesSearch* self)
{
	GtkSearchEntry* _tmp0_;
	GtkViewport* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkListBox* _tmp7_;
#line 83 "../src/widgets/Search.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->_search_entry;
#line 85 "../src/widgets/Search.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, "");
#line 87 "../src/widgets/Search.vala"
	_tmp1_ = self->priv->results_viewport;
#line 87 "../src/widgets/Search.vala"
	_tmp2_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) _tmp1_);
#line 87 "../src/widgets/Search.vala"
	_tmp3_ = _tmp2_;
#line 87 "../src/widgets/Search.vala"
	gtk_adjustment_set_value (_tmp3_, (gdouble) 0);
#line 89 "../src/widgets/Search.vala"
	_tmp4_ = self->priv->results_listbox;
#line 89 "../src/widgets/Search.vala"
	_tmp5_ = gtk_list_box_get_row_at_index (_tmp4_, 0);
#line 89 "../src/widgets/Search.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 89 "../src/widgets/Search.vala"
	row = _tmp6_;
#line 90 "../src/widgets/Search.vala"
	_tmp7_ = self->priv->results_listbox;
#line 90 "../src/widgets/Search.vala"
	gtk_list_box_select_row (_tmp7_, row);
#line 83 "../src/widgets/Search.vala"
	_g_object_unref0 (row);
#line 245 "Search.c"
}

/**
     * Choose selected result
     */
static void
text_pieces_search_activate_selected_result (TextPiecesSearch* self)
{
	GtkListBoxRow* _tmp0_ = NULL;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
#line 96 "../src/widgets/Search.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/widgets/Search.vala"
	_tmp1_ = self->priv->results_listbox;
#line 97 "../src/widgets/Search.vala"
	_tmp2_ = gtk_list_box_get_selected_row (_tmp1_);
#line 97 "../src/widgets/Search.vala"
	_tmp0_ = _tmp2_;
#line 97 "../src/widgets/Search.vala"
	if (_tmp0_ == NULL) {
#line 270 "Search.c"
		GtkListBox* _tmp3_;
		GtkListBoxRow* _tmp4_;
#line 98 "../src/widgets/Search.vala"
		_tmp3_ = self->priv->results_listbox;
#line 98 "../src/widgets/Search.vala"
		_tmp4_ = gtk_list_box_get_row_at_index (_tmp3_, 0);
#line 98 "../src/widgets/Search.vala"
		_tmp0_ = _tmp4_;
#line 279 "Search.c"
	}
#line 97 "../src/widgets/Search.vala"
	_tmp5_ = _g_object_ref0 (_tmp0_);
#line 97 "../src/widgets/Search.vala"
	row = _tmp5_;
#line 99 "../src/widgets/Search.vala"
	_tmp6_ = row;
#line 99 "../src/widgets/Search.vala"
	if (_tmp6_ != NULL) {
#line 289 "Search.c"
		GtkListBox* _tmp7_;
		GtkListBoxRow* _tmp8_;
#line 100 "../src/widgets/Search.vala"
		_tmp7_ = self->priv->results_listbox;
#line 100 "../src/widgets/Search.vala"
		_tmp8_ = row;
#line 100 "../src/widgets/Search.vala"
		g_signal_emit_by_name (_tmp7_, "row-activated", _tmp8_);
#line 298 "Search.c"
	}
#line 96 "../src/widgets/Search.vala"
	_g_object_unref0 (row);
#line 302 "Search.c"
}

/**
     * Process key pressed in search entry
     *
     * Move focus to the first search result
     * if `Gdk.Key.Down` is pressed
     *
     * @param keyval    pressed key value
     * @param keycode   pressed key code
     * @param modifiers pressed modifiers
     *
     * @returnif whether the key press was handled
     */
static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 122 "../src/widgets/Search.vala"
	dup = g_new0 (gboolean, 1);
#line 122 "../src/widgets/Search.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 122 "../src/widgets/Search.vala"
	return dup;
#line 327 "Search.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 122 "../src/widgets/Search.vala"
	return self ? _bool_dup (self) : NULL;
#line 335 "Search.c"
}

static gboolean
text_pieces_search_on_search_entry_key (TextPiecesSearch* self,
                                        guint keyval,
                                        guint keycode,
                                        GdkModifierType modifiers)
{
	gboolean result;
#line 115 "../src/widgets/Search.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../src/widgets/Search.vala"
	switch (keyval) {
#line 118 "../src/widgets/Search.vala"
		case GDK_KEY_Down:
#line 118 "../src/widgets/Search.vala"
		case GDK_KEY_Up:
#line 353 "Search.c"
		{
			GtkListBoxRow* _tmp0_ = NULL;
			GtkListBox* _tmp1_;
			GtkListBoxRow* _tmp2_;
			gboolean* _tmp3_ = NULL;
			GtkEventControllerKey* _tmp6_;
			GtkListBox* _tmp7_;
			GtkSearchEntry* _tmp8_;
#line 122 "../src/widgets/Search.vala"
			_tmp1_ = self->priv->results_listbox;
#line 122 "../src/widgets/Search.vala"
			_tmp2_ = gtk_list_box_get_selected_row (_tmp1_);
#line 122 "../src/widgets/Search.vala"
			_tmp0_ = _tmp2_;
#line 122 "../src/widgets/Search.vala"
			_tmp3_ = NULL;
#line 122 "../src/widgets/Search.vala"
			if (_tmp0_ != NULL) {
#line 372 "Search.c"
				gboolean _tmp4_;
				gboolean* _tmp5_;
#line 122 "../src/widgets/Search.vala"
				_tmp4_ = gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 122 "../src/widgets/Search.vala"
				_tmp5_ = __bool_dup0 (&_tmp4_);
#line 122 "../src/widgets/Search.vala"
				_g_free0 (_tmp3_);
#line 122 "../src/widgets/Search.vala"
				_tmp3_ = _tmp5_;
#line 383 "Search.c"
			}
#line 124 "../src/widgets/Search.vala"
			_tmp6_ = self->priv->search_event_controller;
#line 124 "../src/widgets/Search.vala"
			_tmp7_ = self->priv->results_listbox;
#line 124 "../src/widgets/Search.vala"
			gtk_event_controller_key_forward (_tmp6_, (GtkWidget*) _tmp7_);
#line 126 "../src/widgets/Search.vala"
			_tmp8_ = self->priv->_search_entry;
#line 126 "../src/widgets/Search.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 128 "../src/widgets/Search.vala"
			result = TRUE;
#line 128 "../src/widgets/Search.vala"
			_g_free0 (_tmp3_);
#line 128 "../src/widgets/Search.vala"
			return result;
#line 401 "Search.c"
		}
		default:
		{
#line 130 "../src/widgets/Search.vala"
			result = FALSE;
#line 130 "../src/widgets/Search.vala"
			return result;
#line 409 "Search.c"
		}
	}
}

/**
     * Emit `tool-selected` signal when tool is selected
     */
static void
text_pieces_search_on_row_activated (TextPiecesSearch* self,
                                     GtkListBoxRow* row)
{
	gint index = 0;
	TextPiecesTool* tool = NULL;
	GListModel* _tmp0_;
	GObject* _tmp1_;
#line 138 "../src/widgets/Search.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/widgets/Search.vala"
	g_return_if_fail (row != NULL);
#line 139 "../src/widgets/Search.vala"
	index = gtk_list_box_row_get_index (row);
#line 140 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->results_model;
#line 140 "../src/widgets/Search.vala"
	_tmp1_ = g_list_model_get_item (_tmp0_, (guint) index);
#line 140 "../src/widgets/Search.vala"
	tool = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TEXT_PIECES_TYPE_TOOL, TextPiecesTool);
#line 141 "../src/widgets/Search.vala"
	g_signal_emit (self, text_pieces_search_signals[TEXT_PIECES_SEARCH_TOOL_SELECTED_SIGNAL], 0, tool);
#line 138 "../src/widgets/Search.vala"
	_g_object_unref0 (tool);
#line 441 "Search.c"
}

static void
_text_pieces_search_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                 GtkListBoxRow* row,
                                                                 gpointer self)
{
#line 10 "../src/widgets/Search.vala"
	text_pieces_search_on_row_activated ((TextPiecesSearch*) self, row);
#line 451 "Search.c"
}

/**
     * Update list of search results
     */
static void
text_pieces_search_update_search_results (TextPiecesSearch* self)
{
	GtkSorter* _tmp0_;
	GtkFilter* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBoxRow* _tmp3_;
	const gchar* _tmp7_ = NULL;
	GListModel* _tmp8_;
	GtkStack* _tmp9_;
#line 147 "../src/widgets/Search.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->sorter;
#line 149 "../src/widgets/Search.vala"
	gtk_sorter_changed (_tmp0_, GTK_SORTER_CHANGE_DIFFERENT);
#line 150 "../src/widgets/Search.vala"
	_tmp1_ = self->priv->filter;
#line 150 "../src/widgets/Search.vala"
	gtk_filter_changed (_tmp1_, GTK_FILTER_CHANGE_DIFFERENT);
#line 153 "../src/widgets/Search.vala"
	_tmp2_ = self->priv->results_listbox;
#line 153 "../src/widgets/Search.vala"
	_tmp3_ = gtk_list_box_get_selected_row (_tmp2_);
#line 153 "../src/widgets/Search.vala"
	if (_tmp3_ == NULL) {
#line 483 "Search.c"
		GtkListBox* _tmp4_;
		GtkListBox* _tmp5_;
		GtkListBoxRow* _tmp6_;
#line 154 "../src/widgets/Search.vala"
		_tmp4_ = self->priv->results_listbox;
#line 154 "../src/widgets/Search.vala"
		_tmp5_ = self->priv->results_listbox;
#line 154 "../src/widgets/Search.vala"
		_tmp6_ = gtk_list_box_get_row_at_index (_tmp5_, 0);
#line 154 "../src/widgets/Search.vala"
		gtk_list_box_select_row (_tmp4_, _tmp6_);
#line 495 "Search.c"
	}
#line 162 "../src/widgets/Search.vala"
	_tmp8_ = self->priv->results_model;
#line 162 "../src/widgets/Search.vala"
	if (g_list_model_get_n_items (_tmp8_) == ((guint) 0)) {
#line 163 "../src/widgets/Search.vala"
		_tmp7_ = "placeholder";
#line 503 "Search.c"
	} else {
#line 164 "../src/widgets/Search.vala"
		_tmp7_ = "search";
#line 507 "Search.c"
	}
#line 161 "../src/widgets/Search.vala"
	_tmp9_ = self->priv->search_stack;
#line 161 "../src/widgets/Search.vala"
	gtk_stack_set_visible_child_name (_tmp9_, _tmp7_);
#line 513 "Search.c"
}

/**
     * Compare tools by search irrelevance
     *
     * Less relevant tool should be
     * larger than more relevant
     * to be below more relevant tool
     * in search results. If tools are
     * equal, compare tools' names.
     *
     * @param a one tool
     * @param b another tool
     *
     * @return zero if tools are equal, positive if `a` is larger, negative otherwise
     */
gint
text_pieces_search_tool_sort_func (TextPiecesSearch* self,
                                   TextPiecesTool* a,
                                   TextPiecesTool* b)
{
	gchar* query = NULL;
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint res = 0;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint result;
#line 182 "../src/widgets/Search.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 182 "../src/widgets/Search.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 182 "../src/widgets/Search.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 183 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->_search_entry;
#line 183 "../src/widgets/Search.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 183 "../src/widgets/Search.vala"
	_tmp2_ = _tmp1_;
#line 183 "../src/widgets/Search.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 183 "../src/widgets/Search.vala"
	query = _tmp3_;
#line 185 "../src/widgets/Search.vala"
	_tmp4_ = query;
#line 185 "../src/widgets/Search.vala"
	_tmp5_ = query;
#line 185 "../src/widgets/Search.vala"
	res = text_pieces_search_calculate_irrelevance (a, _tmp4_) - text_pieces_search_calculate_irrelevance (b, _tmp5_);
#line 187 "../src/widgets/Search.vala"
	if (res == 0) {
#line 568 "Search.c"
		GCompareFunc _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 188 "../src/widgets/Search.vala"
		_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 188 "../src/widgets/Search.vala"
		_tmp7_ = text_pieces_tool_get_translated_name (a);
#line 188 "../src/widgets/Search.vala"
		_tmp8_ = _tmp7_;
#line 188 "../src/widgets/Search.vala"
		_tmp9_ = text_pieces_tool_get_translated_name (b);
#line 188 "../src/widgets/Search.vala"
		_tmp10_ = _tmp9_;
#line 188 "../src/widgets/Search.vala"
		result = _tmp6_ (_tmp8_, _tmp10_);
#line 188 "../src/widgets/Search.vala"
		_g_free0 (query);
#line 188 "../src/widgets/Search.vala"
		return result;
#line 590 "Search.c"
	}
#line 189 "../src/widgets/Search.vala"
	result = res;
#line 189 "../src/widgets/Search.vala"
	_g_free0 (query);
#line 189 "../src/widgets/Search.vala"
	return result;
#line 598 "Search.c"
}

/**
     * Functions used to filter tools by search relevance
     *
     * Don't show tool if its irrelevance is infinite
     *
     * @param tool  the tool
     * @param query search query
     *
     * @return whether to show tool in search results
     */
gboolean
text_pieces_search_tool_filter_func (TextPiecesSearch* self,
                                     GObject* tool)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 202 "../src/widgets/Search.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/widgets/Search.vala"
	g_return_val_if_fail (tool != NULL, FALSE);
#line 203 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->_search_entry;
#line 203 "../src/widgets/Search.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 203 "../src/widgets/Search.vala"
	_tmp2_ = _tmp1_;
#line 203 "../src/widgets/Search.vala"
	result = text_pieces_search_calculate_irrelevance (G_TYPE_CHECK_INSTANCE_CAST (tool, TEXT_PIECES_TYPE_TOOL, TextPiecesTool), _tmp2_) != G_MAXINT;
#line 203 "../src/widgets/Search.vala"
	return result;
#line 633 "Search.c"
}

/**
     * Calculate tool irrelevance
     *
     * This method is used to filter
     * and sort search results
     *
     * @param tool  the tool
     * @param query search query
     *
     * @return tool's search irrelevance
     */
static gint
text_pieces_search_calculate_irrelevance (TextPiecesTool* tool,
                                          const gchar* query)
{
	gchar* casefolded_query = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gint _tmp17_;
	gint result;
#line 217 "../src/widgets/Search.vala"
	g_return_val_if_fail (tool != NULL, 0);
#line 217 "../src/widgets/Search.vala"
	g_return_val_if_fail (query != NULL, 0);
#line 219 "../src/widgets/Search.vala"
	_tmp0_ = g_utf8_casefold (query, (gssize) -1);
#line 219 "../src/widgets/Search.vala"
	casefolded_query = _tmp0_;
#line 221 "../src/widgets/Search.vala"
	_tmp1_ = text_pieces_tool_get_name (tool);
#line 221 "../src/widgets/Search.vala"
	_tmp2_ = _tmp1_;
#line 221 "../src/widgets/Search.vala"
	_tmp3_ = g_utf8_casefold (_tmp2_, (gssize) -1);
#line 221 "../src/widgets/Search.vala"
	_tmp4_ = text_pieces_tool_get_description (tool);
#line 221 "../src/widgets/Search.vala"
	_tmp5_ = _tmp4_;
#line 221 "../src/widgets/Search.vala"
	_tmp6_ = g_utf8_casefold (_tmp5_, (gssize) -1);
#line 221 "../src/widgets/Search.vala"
	_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 221 "../src/widgets/Search.vala"
	_tmp7_[0] = _tmp3_;
#line 221 "../src/widgets/Search.vala"
	_tmp7_[1] = _tmp6_;
#line 221 "../src/widgets/Search.vala"
	_tmp8_ = _tmp7_;
#line 221 "../src/widgets/Search.vala"
	_tmp8__length1 = 2;
#line 221 "../src/widgets/Search.vala"
	_tmp9_ = text_pieces_tool_get_translated_name (tool);
#line 221 "../src/widgets/Search.vala"
	_tmp10_ = _tmp9_;
#line 221 "../src/widgets/Search.vala"
	_tmp11_ = g_utf8_casefold (_tmp10_, (gssize) -1);
#line 221 "../src/widgets/Search.vala"
	_tmp12_ = text_pieces_tool_get_translated_description (tool);
#line 221 "../src/widgets/Search.vala"
	_tmp13_ = _tmp12_;
#line 221 "../src/widgets/Search.vala"
	_tmp14_ = g_utf8_casefold (_tmp13_, (gssize) -1);
#line 221 "../src/widgets/Search.vala"
	_tmp15_ = g_new0 (gchar*, 2 + 1);
#line 221 "../src/widgets/Search.vala"
	_tmp15_[0] = _tmp11_;
#line 221 "../src/widgets/Search.vala"
	_tmp15_[1] = _tmp14_;
#line 221 "../src/widgets/Search.vala"
	_tmp16_ = _tmp15_;
#line 221 "../src/widgets/Search.vala"
	_tmp16__length1 = 2;
#line 221 "../src/widgets/Search.vala"
	_tmp17_ = MIN (text_pieces_search_calculate_irrelevance_for_fields (_tmp8_, (gint) 2, casefolded_query), text_pieces_search_calculate_irrelevance_for_fields (_tmp16_, (gint) 2, casefolded_query));
#line 221 "../src/widgets/Search.vala"
	_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
#line 221 "../src/widgets/Search.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 221 "../src/widgets/Search.vala"
	result = _tmp17_;
#line 221 "../src/widgets/Search.vala"
	_g_free0 (casefolded_query);
#line 221 "../src/widgets/Search.vala"
	return result;
#line 737 "Search.c"
}

/**
     * Calculate fields' irrelevance
     *
     * This method gets list of fields
     * and search query and returns fields'
     * search irrelevance. The alghorythm is as follows:
     *
     * 1. If query is empty string, algorythm finishes,
     *    irrelevance is zero. It's used to fallback
     *    to alphabetical sort.
     * 2. At the start of the alghorythm irrelevance
     *    is equals to zero
     * 3. Query is divided into words, called terms
     * 4. Algorythm iterates over terms
     * 5. I search for term in fields, from the first
     *    field to the last field
     * 6. If term is not found, algorythm finishes,
     *    irrelevance is infinite
     * 7. If term is found in the field, increase
     *    irrelevance by the difference from the index of
     *    the match start and then cut out part of field
     *    from the start of field to the end of match
     * 8. At the end of the algorythm, increase
     *    irrelevance by sum of lengths of first fields
     *    which don't contain any terms
     *
     * @param fields list of the fields
     * @param query  search query
     *
     * @return tool's search irrelevance
     */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 792 "Search.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 800 "Search.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 806 "Search.c"
	}
}

static gint
text_pieces_search_calculate_irrelevance_for_fields (gchar** fields,
                                                     gint fields_length1,
                                                     const gchar* query)
{
	gchar** terms = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint terms_length1;
	gint _terms_size_;
	gint* field_beginning = NULL;
	gint* _tmp2_;
	gint field_beginning_length1;
	gint _field_beginning_size_;
	gint irrelevance = 0;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint result;
#line 266 "../src/widgets/Search.vala"
	g_return_val_if_fail (query != NULL, 0);
#line 268 "../src/widgets/Search.vala"
	if (g_strcmp0 (query, "") == 0) {
#line 269 "../src/widgets/Search.vala"
		result = 0;
#line 269 "../src/widgets/Search.vala"
		return result;
#line 836 "Search.c"
	}
#line 272 "../src/widgets/Search.vala"
	_tmp1_ = _tmp0_ = g_strsplit (query, " ", 0);
#line 272 "../src/widgets/Search.vala"
	terms = _tmp1_;
#line 272 "../src/widgets/Search.vala"
	terms_length1 = _vala_array_length (_tmp0_);
#line 272 "../src/widgets/Search.vala"
	_terms_size_ = terms_length1;
#line 277 "../src/widgets/Search.vala"
	_tmp2_ = g_new0 (gint, fields_length1);
#line 277 "../src/widgets/Search.vala"
	field_beginning = _tmp2_;
#line 277 "../src/widgets/Search.vala"
	field_beginning_length1 = fields_length1;
#line 277 "../src/widgets/Search.vala"
	_field_beginning_size_ = field_beginning_length1;
#line 280 "../src/widgets/Search.vala"
	irrelevance = 0;
#line 283 "../src/widgets/Search.vala"
	_tmp3_ = terms;
#line 283 "../src/widgets/Search.vala"
	_tmp3__length1 = terms_length1;
#line 860 "Search.c"
	{
		gchar** term_collection = NULL;
		gint term_collection_length1 = 0;
		gint _term_collection_size_ = 0;
		gint term_it = 0;
#line 283 "../src/widgets/Search.vala"
		term_collection = _tmp3_;
#line 283 "../src/widgets/Search.vala"
		term_collection_length1 = _tmp3__length1;
#line 283 "../src/widgets/Search.vala"
		for (term_it = 0; term_it < term_collection_length1; term_it = term_it + 1) {
#line 872 "Search.c"
			gchar* _tmp4_;
			gchar* term = NULL;
#line 283 "../src/widgets/Search.vala"
			_tmp4_ = g_strdup (term_collection[term_it]);
#line 283 "../src/widgets/Search.vala"
			term = _tmp4_;
#line 879 "Search.c"
			{
				gint matching_field = 0;
				gint match = 0;
				gint* _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				gint* _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 285 "../src/widgets/Search.vala"
				matching_field = 0;
#line 286 "../src/widgets/Search.vala"
				match = 0;
#line 288 "../src/widgets/Search.vala"
				while (TRUE) {
#line 897 "Search.c"
					gboolean _tmp5_ = FALSE;
					gint _tmp10_;
#line 288 "../src/widgets/Search.vala"
					if (matching_field < fields_length1) {
#line 902 "Search.c"
						const gchar* _tmp6_;
						const gchar* _tmp7_;
						gint* _tmp8_;
						gint _tmp8__length1;
						gint _tmp9_;
#line 289 "../src/widgets/Search.vala"
						_tmp6_ = fields[matching_field];
#line 289 "../src/widgets/Search.vala"
						_tmp7_ = term;
#line 289 "../src/widgets/Search.vala"
						_tmp8_ = field_beginning;
#line 289 "../src/widgets/Search.vala"
						_tmp8__length1 = field_beginning_length1;
#line 289 "../src/widgets/Search.vala"
						_tmp9_ = _tmp8_[matching_field];
#line 289 "../src/widgets/Search.vala"
						match = string_index_of (_tmp6_, _tmp7_, _tmp9_);
#line 289 "../src/widgets/Search.vala"
						_tmp5_ = match == -1;
#line 922 "Search.c"
					} else {
#line 288 "../src/widgets/Search.vala"
						_tmp5_ = FALSE;
#line 926 "Search.c"
					}
#line 288 "../src/widgets/Search.vala"
					if (!_tmp5_) {
#line 288 "../src/widgets/Search.vala"
						break;
#line 932 "Search.c"
					}
#line 290 "../src/widgets/Search.vala"
					_tmp10_ = matching_field;
#line 290 "../src/widgets/Search.vala"
					matching_field = _tmp10_ + 1;
#line 938 "Search.c"
				}
#line 295 "../src/widgets/Search.vala"
				if (match == -1) {
#line 296 "../src/widgets/Search.vala"
					result = G_MAXINT;
#line 296 "../src/widgets/Search.vala"
					_g_free0 (term);
#line 296 "../src/widgets/Search.vala"
					field_beginning = (g_free (field_beginning), NULL);
#line 296 "../src/widgets/Search.vala"
					terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
#line 296 "../src/widgets/Search.vala"
					return result;
#line 952 "Search.c"
				}
#line 300 "../src/widgets/Search.vala"
				_tmp11_ = field_beginning;
#line 300 "../src/widgets/Search.vala"
				_tmp11__length1 = field_beginning_length1;
#line 300 "../src/widgets/Search.vala"
				_tmp12_ = _tmp11_[matching_field];
#line 300 "../src/widgets/Search.vala"
				irrelevance += match - _tmp12_;
#line 303 "../src/widgets/Search.vala"
				_tmp13_ = field_beginning;
#line 303 "../src/widgets/Search.vala"
				_tmp13__length1 = field_beginning_length1;
#line 303 "../src/widgets/Search.vala"
				_tmp14_ = term;
#line 303 "../src/widgets/Search.vala"
				_tmp15_ = strlen (_tmp14_);
#line 303 "../src/widgets/Search.vala"
				_tmp16_ = _tmp15_;
#line 303 "../src/widgets/Search.vala"
				_tmp13_[matching_field] = match + _tmp16_;
#line 283 "../src/widgets/Search.vala"
				_g_free0 (term);
#line 976 "Search.c"
			}
		}
	}
	{
		gint i = 0;
#line 308 "../src/widgets/Search.vala"
		i = 0;
#line 984 "Search.c"
		{
			gboolean _tmp17_ = FALSE;
#line 308 "../src/widgets/Search.vala"
			_tmp17_ = TRUE;
#line 308 "../src/widgets/Search.vala"
			while (TRUE) {
#line 991 "Search.c"
				gboolean _tmp19_ = FALSE;
				gint* _tmp20_;
				gint _tmp20__length1;
				const gchar* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 308 "../src/widgets/Search.vala"
				if (!_tmp17_) {
#line 1000 "Search.c"
					gint _tmp18_;
#line 308 "../src/widgets/Search.vala"
					_tmp18_ = i;
#line 308 "../src/widgets/Search.vala"
					i = _tmp18_ + 1;
#line 1006 "Search.c"
				}
#line 308 "../src/widgets/Search.vala"
				_tmp17_ = FALSE;
#line 308 "../src/widgets/Search.vala"
				_tmp20_ = field_beginning;
#line 308 "../src/widgets/Search.vala"
				_tmp20__length1 = field_beginning_length1;
#line 308 "../src/widgets/Search.vala"
				if (i < _tmp20__length1) {
#line 1016 "Search.c"
					gint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
#line 308 "../src/widgets/Search.vala"
					_tmp21_ = field_beginning;
#line 308 "../src/widgets/Search.vala"
					_tmp21__length1 = field_beginning_length1;
#line 308 "../src/widgets/Search.vala"
					_tmp22_ = _tmp21_[i];
#line 308 "../src/widgets/Search.vala"
					_tmp19_ = _tmp22_ == 0;
#line 1028 "Search.c"
				} else {
#line 308 "../src/widgets/Search.vala"
					_tmp19_ = FALSE;
#line 1032 "Search.c"
				}
#line 308 "../src/widgets/Search.vala"
				if (!_tmp19_) {
#line 308 "../src/widgets/Search.vala"
					break;
#line 1038 "Search.c"
				}
#line 309 "../src/widgets/Search.vala"
				_tmp23_ = fields[i];
#line 309 "../src/widgets/Search.vala"
				_tmp24_ = strlen (_tmp23_);
#line 309 "../src/widgets/Search.vala"
				_tmp25_ = _tmp24_;
#line 309 "../src/widgets/Search.vala"
				irrelevance += _tmp25_;
#line 1048 "Search.c"
			}
		}
	}
#line 312 "../src/widgets/Search.vala"
	result = irrelevance;
#line 312 "../src/widgets/Search.vala"
	field_beginning = (g_free (field_beginning), NULL);
#line 312 "../src/widgets/Search.vala"
	terms = (_vala_array_free (terms, terms_length1, (GDestroyNotify) g_free), NULL);
#line 312 "../src/widgets/Search.vala"
	return result;
#line 1060 "Search.c"
}

TextPiecesSearch*
text_pieces_search_construct (GType object_type)
{
	TextPiecesSearch * self = NULL;
#line 10 "../src/widgets/Search.vala"
	self = (TextPiecesSearch*) g_object_new (object_type, NULL);
#line 10 "../src/widgets/Search.vala"
	return self;
#line 1071 "Search.c"
}

TextPiecesSearch*
text_pieces_search_new (void)
{
#line 10 "../src/widgets/Search.vala"
	return text_pieces_search_construct (TEXT_PIECES_TYPE_SEARCH);
#line 1079 "Search.c"
}

GtkSearchEntry*
text_pieces_search_get_search_entry (TextPiecesSearch* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
#line 18 "../src/widgets/Search.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/widgets/Search.vala"
	_tmp0_ = self->priv->_search_entry;
#line 18 "../src/widgets/Search.vala"
	result = _tmp0_;
#line 18 "../src/widgets/Search.vala"
	return result;
#line 1095 "Search.c"
}

static void
text_pieces_search_set_search_entry (TextPiecesSearch* self,
                                     GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
#line 18 "../src/widgets/Search.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/widgets/Search.vala"
	old_value = text_pieces_search_get_search_entry (self);
#line 18 "../src/widgets/Search.vala"
	if (old_value != value) {
#line 1109 "Search.c"
		GtkSearchEntry* _tmp0_;
#line 18 "../src/widgets/Search.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/widgets/Search.vala"
		_g_object_unref0 (self->priv->_search_entry);
#line 18 "../src/widgets/Search.vala"
		self->priv->_search_entry = _tmp0_;
#line 18 "../src/widgets/Search.vala"
		g_object_notify_by_pspec ((GObject *) self, text_pieces_search_properties[TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY]);
#line 1119 "Search.c"
	}
}

static gint
_text_pieces_search___lambda18_ (TextPiecesSearch* self,
                                 gconstpointer a,
                                 gconstpointer b)
{
	gint result;
#line 42 "../src/widgets/Search.vala"
	result = text_pieces_search_tool_sort_func (self, G_TYPE_CHECK_INSTANCE_CAST (a, TEXT_PIECES_TYPE_TOOL, TextPiecesTool), G_TYPE_CHECK_INSTANCE_CAST (b, TEXT_PIECES_TYPE_TOOL, TextPiecesTool));
#line 42 "../src/widgets/Search.vala"
	return result;
#line 1133 "Search.c"
}

static gint
__text_pieces_search___lambda18__gcompare_data_func (gconstpointer a,
                                                     gconstpointer b,
                                                     gpointer self)
{
	gint result;
	result = _text_pieces_search___lambda18_ ((TextPiecesSearch*) self, a, b);
#line 42 "../src/widgets/Search.vala"
	return result;
#line 1145 "Search.c"
}

static gboolean
_text_pieces_search_tool_filter_func_gtk_custom_filter_func (GObject* item,
                                                             gpointer self)
{
	gboolean result;
	result = text_pieces_search_tool_filter_func ((TextPiecesSearch*) self, item);
#line 43 "../src/widgets/Search.vala"
	return result;
#line 1156 "Search.c"
}

static GtkWidget*
_text_pieces_build_list_row_gtk_list_box_create_widget_func (GObject* item,
                                                             gpointer self)
{
	GtkWidget* result;
	result = text_pieces_build_list_row (item);
#line 53 "../src/widgets/Search.vala"
	return result;
#line 1167 "Search.c"
}

static void
_text_pieces_search_update_search_results_gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self)
{
#line 59 "../src/widgets/Search.vala"
	text_pieces_search_update_search_results ((TextPiecesSearch*) self);
#line 1176 "Search.c"
}

static void
_text_pieces_search_activate_selected_result_gtk_search_entry_activate (GtkSearchEntry* _sender,
                                                                        gpointer self)
{
#line 62 "../src/widgets/Search.vala"
	text_pieces_search_activate_selected_result ((TextPiecesSearch*) self);
#line 1185 "Search.c"
}

static gboolean
_text_pieces_search_on_search_entry_key_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                              guint keyval,
                                                                              guint keycode,
                                                                              GdkModifierType state,
                                                                              gpointer self)
{
	gboolean result;
	result = text_pieces_search_on_search_entry_key ((TextPiecesSearch*) self, keyval, keycode, state);
#line 67 "../src/widgets/Search.vala"
	return result;
#line 1199 "Search.c"
}

static GObject *
text_pieces_search_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TextPiecesSearch * self;
	GtkCustomSorter* _tmp0_;
	GtkCustomFilter* _tmp1_;
	TextPiecesToolsController* _tmp2_;
	GListStore* _tmp3_;
	GListStore* _tmp4_;
	GListModel* _tmp5_;
	GtkFilter* _tmp6_;
	GtkFilter* _tmp7_;
	GtkFilterListModel* _tmp8_;
	GtkSorter* _tmp9_;
	GtkSorter* _tmp10_;
	GtkSortListModel* _tmp11_;
	GtkListBox* _tmp12_;
	GListModel* _tmp13_;
	GtkSearchEntry* _tmp14_;
	GtkSearchEntry* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkEventControllerKey* _tmp17_;
	GtkSearchEntry* _tmp18_;
	GtkEventControllerKey* _tmp19_;
	GtkEventController* _tmp20_;
#line 40 "../src/widgets/Search.vala"
	parent_class = G_OBJECT_CLASS (text_pieces_search_parent_class);
#line 40 "../src/widgets/Search.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/widgets/Search.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TEXT_PIECES_TYPE_SEARCH, TextPiecesSearch);
#line 42 "../src/widgets/Search.vala"
	_tmp0_ = gtk_custom_sorter_new (__text_pieces_search___lambda18__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 42 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->sorter);
#line 42 "../src/widgets/Search.vala"
	self->priv->sorter = (GtkSorter*) _tmp0_;
#line 43 "../src/widgets/Search.vala"
	_tmp1_ = gtk_custom_filter_new (_text_pieces_search_tool_filter_func_gtk_custom_filter_func, g_object_ref (self), g_object_unref);
#line 43 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->filter);
#line 43 "../src/widgets/Search.vala"
	self->priv->filter = (GtkFilter*) _tmp1_;
#line 44 "../src/widgets/Search.vala"
	_tmp2_ = text_pieces_application_tools;
#line 44 "../src/widgets/Search.vala"
	_tmp3_ = text_pieces_tools_controller_get_all_tools (_tmp2_);
#line 44 "../src/widgets/Search.vala"
	_tmp4_ = _tmp3_;
#line 44 "../src/widgets/Search.vala"
	_tmp5_ = _g_object_ref0 ((GListModel*) _tmp4_);
#line 44 "../src/widgets/Search.vala"
	_tmp6_ = self->priv->filter;
#line 44 "../src/widgets/Search.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 44 "../src/widgets/Search.vala"
	_tmp8_ = gtk_filter_list_model_new (_tmp5_, _tmp7_);
#line 44 "../src/widgets/Search.vala"
	_tmp9_ = self->priv->sorter;
#line 44 "../src/widgets/Search.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 44 "../src/widgets/Search.vala"
	_tmp11_ = gtk_sort_list_model_new ((GListModel*) _tmp8_, _tmp10_);
#line 44 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->results_model);
#line 44 "../src/widgets/Search.vala"
	self->priv->results_model = (GListModel*) _tmp11_;
#line 53 "../src/widgets/Search.vala"
	_tmp12_ = self->priv->results_listbox;
#line 53 "../src/widgets/Search.vala"
	_tmp13_ = self->priv->results_model;
#line 53 "../src/widgets/Search.vala"
	gtk_list_box_bind_model (_tmp12_, _tmp13_, _text_pieces_build_list_row_gtk_list_box_create_widget_func, NULL, NULL);
#line 59 "../src/widgets/Search.vala"
	_tmp14_ = self->priv->_search_entry;
#line 59 "../src/widgets/Search.vala"
	g_signal_connect_object ((GtkEditable*) _tmp14_, "changed", (GCallback) _text_pieces_search_update_search_results_gtk_editable_changed, self, 0);
#line 62 "../src/widgets/Search.vala"
	_tmp15_ = self->priv->_search_entry;
#line 62 "../src/widgets/Search.vala"
	g_signal_connect_object (_tmp15_, "activate", (GCallback) _text_pieces_search_activate_selected_result_gtk_search_entry_activate, self, 0);
#line 66 "../src/widgets/Search.vala"
	_tmp16_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 66 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->search_event_controller);
#line 66 "../src/widgets/Search.vala"
	self->priv->search_event_controller = _tmp16_;
#line 67 "../src/widgets/Search.vala"
	_tmp17_ = self->priv->search_event_controller;
#line 67 "../src/widgets/Search.vala"
	g_signal_connect_object (_tmp17_, "key-pressed", (GCallback) _text_pieces_search_on_search_entry_key_gtk_event_controller_key_key_pressed, self, 0);
#line 68 "../src/widgets/Search.vala"
	_tmp18_ = self->priv->_search_entry;
#line 68 "../src/widgets/Search.vala"
	_tmp19_ = self->priv->search_event_controller;
#line 68 "../src/widgets/Search.vala"
	_tmp20_ = _g_object_ref0 ((GtkEventController*) _tmp19_);
#line 68 "../src/widgets/Search.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp18_, _tmp20_);
#line 40 "../src/widgets/Search.vala"
	return obj;
#line 1307 "Search.c"
}

static void
text_pieces_search_class_init (TextPiecesSearchClass * klass,
                               gpointer klass_data)
{
#line 10 "../src/widgets/Search.vala"
	text_pieces_search_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/widgets/Search.vala"
	g_type_class_adjust_private_offset (klass, &TextPiecesSearch_private_offset);
#line 10 "../src/widgets/Search.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_text_pieces_search_get_property;
#line 10 "../src/widgets/Search.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_text_pieces_search_set_property;
#line 10 "../src/widgets/Search.vala"
	G_OBJECT_CLASS (klass)->constructor = text_pieces_search_constructor;
#line 10 "../src/widgets/Search.vala"
	G_OBJECT_CLASS (klass)->finalize = text_pieces_search_finalize;
#line 1326 "Search.c"
	/**
	     * Search entry to use
	     */
#line 10 "../src/widgets/Search.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY, text_pieces_search_properties[TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY] = g_param_spec_object ("search-entry", "search-entry", "search-entry", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/widgets/Search.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/liferooter/textpieces/ui/Search.ui");
#line 1334 "Search.c"
	/**
	     * Emitted when a tool is selected
	     *
	     * @param tool selected tool
	     */
#line 10 "../src/widgets/Search.vala"
	text_pieces_search_signals[TEXT_PIECES_SEARCH_TOOL_SELECTED_SIGNAL] = g_signal_new ("tool-selected", TEXT_PIECES_TYPE_SEARCH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TEXT_PIECES_TYPE_TOOL);
#line 10 "../src/widgets/Search.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "results_viewport", FALSE, TextPiecesSearch_private_offset + G_STRUCT_OFFSET (TextPiecesSearchPrivate, results_viewport));
#line 10 "../src/widgets/Search.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "results_listbox", FALSE, TextPiecesSearch_private_offset + G_STRUCT_OFFSET (TextPiecesSearchPrivate, results_listbox));
#line 10 "../src/widgets/Search.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_stack", FALSE, TextPiecesSearch_private_offset + G_STRUCT_OFFSET (TextPiecesSearchPrivate, search_stack));
#line 10 "../src/widgets/Search.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_row_activated", G_CALLBACK(_text_pieces_search_on_row_activated_gtk_list_box_row_activated));
#line 1350 "Search.c"
}

static void
text_pieces_search_instance_init (TextPiecesSearch * self,
                                  gpointer klass)
{
#line 10 "../src/widgets/Search.vala"
	self->priv = text_pieces_search_get_instance_private (self);
#line 18 "../src/widgets/Search.vala"
	self->priv->_search_entry = NULL;
#line 10 "../src/widgets/Search.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1363 "Search.c"
}

static void
text_pieces_search_finalize (GObject * obj)
{
	TextPiecesSearch * self;
#line 10 "../src/widgets/Search.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TEXT_PIECES_TYPE_SEARCH, TextPiecesSearch);
#line 18 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->_search_entry);
#line 23 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->results_model);
#line 28 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->sorter);
#line 33 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->filter);
#line 38 "../src/widgets/Search.vala"
	_g_object_unref0 (self->priv->search_event_controller);
#line 10 "../src/widgets/Search.vala"
	G_OBJECT_CLASS (text_pieces_search_parent_class)->finalize (obj);
#line 1384 "Search.c"
}

static GType
text_pieces_search_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TextPiecesSearchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_pieces_search_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextPiecesSearch), 0, (GInstanceInitFunc) text_pieces_search_instance_init, NULL };
	GType text_pieces_search_type_id;
	text_pieces_search_type_id = g_type_register_static (adw_bin_get_type (), "TextPiecesSearch", &g_define_type_info, 0);
	TextPiecesSearch_private_offset = g_type_add_instance_private (text_pieces_search_type_id, sizeof (TextPiecesSearchPrivate));
	return text_pieces_search_type_id;
}

GType
text_pieces_search_get_type (void)
{
	static volatile gsize text_pieces_search_type_id__once = 0;
	if (g_once_init_enter (&text_pieces_search_type_id__once)) {
		GType text_pieces_search_type_id;
		text_pieces_search_type_id = text_pieces_search_get_type_once ();
		g_once_init_leave (&text_pieces_search_type_id__once, text_pieces_search_type_id);
	}
	return text_pieces_search_type_id__once;
}

static void
_vala_text_pieces_search_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	TextPiecesSearch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TEXT_PIECES_TYPE_SEARCH, TextPiecesSearch);
#line 10 "../src/widgets/Search.vala"
	switch (property_id) {
#line 10 "../src/widgets/Search.vala"
		case TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY:
#line 10 "../src/widgets/Search.vala"
		g_value_set_object (value, text_pieces_search_get_search_entry (self));
#line 10 "../src/widgets/Search.vala"
		break;
#line 1425 "Search.c"
		default:
#line 10 "../src/widgets/Search.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/widgets/Search.vala"
		break;
#line 1431 "Search.c"
	}
}

static void
_vala_text_pieces_search_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	TextPiecesSearch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TEXT_PIECES_TYPE_SEARCH, TextPiecesSearch);
#line 10 "../src/widgets/Search.vala"
	switch (property_id) {
#line 10 "../src/widgets/Search.vala"
		case TEXT_PIECES_SEARCH_SEARCH_ENTRY_PROPERTY:
#line 10 "../src/widgets/Search.vala"
		text_pieces_search_set_search_entry (self, g_value_get_object (value));
#line 10 "../src/widgets/Search.vala"
		break;
#line 1451 "Search.c"
		default:
#line 10 "../src/widgets/Search.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/widgets/Search.vala"
		break;
#line 1457 "Search.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

